#!/usr/bin/python

# Example call: http://192.168.1.50/cgi-bin/stream.py?url=http://wizz.cc/coucou.mp3
#

import cgi
import os
import subprocess
import sys
import urllib
import md5
import simplejson as json
import time
import base64


def RunCommand(cmd):
    return os.system(cmd)

def IsBusy():
	busy = os.system("/usr/karotz/FreeRabbits/StopSound >/dev/null 2>/dev/null")
	return (busy != 0)

def IsSleeping():
	return os.path.isfile("/tmp/karotz.sleep") or os.path.isfile("/usr/openkarotz/Run/karotz.sleep")

def LEDPulse(ledcolor):
	cmd = "dbus-send --system --dest=com.mindscape.karotz.Led /com/mindscape/karotz/Led com.mindscape.karotz.KarotzInterface.pulse string:\"\" string:\"" + ledcolor + "\" string:\"000000\" int32:700 int32:-1 "
	RunCommand(cmd)

def RunApp(appid):
    subprocess.Popen(["python", "/usr/karotz/FreeRabbits/commander.py", appid], stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    return 0

def StopMusic():
	RunCommand("/usr/karotz/FreeRabbits/StopSound")
	# RunCommand("/bin/killall musicloop.sh >/dev/null 2>/dev/null")
	# RunCommand("/bin/killall madplay >/dev/null 2>/dev/null")
	# RunCommand("/bin/killall mplayer >/dev/null 2>/dev/null")
	return 0

def Play(mp3file, bg):
	# PlayWebSound
	cmd = "/usr/karotz/FreeRabbits/PlaySound /usr/karotz/FreeRabbits/Sounds/" + mp3file + ".mp3 " + str(bg)
	return RunCommand(cmd)

def PlayMP3(mp3file):
	cmd = "/usr/bin/madplay -q /usr/karotz/FreeRabbits/Sounds/" + mp3file + ".mp3 >/dev/null 2>&1 &"
	return RunCommand(cmd)

def PlayURL(mp3url):
	# cmd = "/usr/bin/mplayer -quiet \"" + mp3file + "\" >/dev/null 2>&1 &"
	cmd = "mplayer \"" + mp3url + "\" >/dev/null 2>&1 &"
	return RunCommand(cmd)

# Main program
#
url    = ""
msg    = ""
result = 1
fields = cgi.FieldStorage()

if "url" in fields:
	if not "b64" in fields:
		url = fields["url"].value
	else:
		url = base64.b64decode(fields["url"].value)
	if not IsSleeping():
		Play("clocktick", 1)
		time.sleep(1)
		LEDPulse("FFA500")
		StopMusic()
		LEDPulse("00FF00")
		msg = "URL to stream: " + url
		result = PlayURL(url)
	else:
		msg = "Rabbit is sleeping"
else:
	msg = "No url to stream"

# Create the JSON object
data = {}
data["return"] = (result == 0)
data["message"] = msg

# Write Output Response
print "Server: OpenKarotz WebServer 1.0"
print "Connection: close"
print "Accept-Ranges: bytes"
print "Content-type: text/plain"
print "Access-Control-Allow-Origin: *"
print
print json.dumps(data)
